import PropTypes from 'prop-types';
import React, {useState} from 'react';

function Validator({children: Children, id: Id}) {
    const [state] = useState({
        validators: {}
    });

    if(undefined === state.validators[Id]) {
        state.validators[Id] = {};
    }

    const processElement = (el, index) => {
        if("function" === typeof el.type) {
            if(-1 !== Object.keys(Validator).indexOf(el.type.name)) {
                state.validators[Id][index] = Validator[el.type.name].Rule(el.props.value);
                return <el.type rfivResult={state.validators[Id][index]} {...el.props}>{el.props.children}</el.type>;
            }
        } else if(undefined !== el.props && undefined !== el.props.children) {
            return <el.type {...el.props}>{processElement(el.props.children, index)}</el.type>;
        }
        return el;
    };

    const children = React.Children.map(Children, processElement);
    return (
        <>{children}</>
    );
}

const IsEmail = ({children: Children, includeDiv: IncludeDiv = true, rfivResult: RfivResult, value}) => {
    return RfivResult ? (IncludeDiv ? <div className={'rfiv-error'}>{Children}</div> : {Children}) : <></>;
};
IsEmail.propTypes = {
    children: PropTypes.element.isRequired
};
IsEmail.Rule = (value) => {
    return undefined !== value && value.length > 0 && false === /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(String(value).toLowerCase());
};

Validator.IsEmail = IsEmail;

/*if(-1 !== ["IsEmail", "Required"].indexOf(el.type.name)) {
    state.validators[Id][index] = el.type(el.props);
    if (state.validators[Id][index]) {
        return <div className={'error'}>{el.props.children}</div>;
    }
    return;
} else if("Message" === el.type.name) {
    return <div className={'message'}>{el.props.children}</div>;
} else if("Submit" === el.type.name) {
    let disabled = false;
    for(let key in state.validators[Id]) {
        if(state.validators[Id][key]) {
            disabled = true;
            break;
        }
    }
    return <div className={(el.props.waiting ? 'waiting' : 'btn btn-success') + (disabled ? ' disabled' : '')}
                onClick={disabled ? null : el.props.onClick}
                style={{marginTop:'10px'}}>{el.props.waiting ? '                 ' : el.props.children}</div>;
}*/
/*const IsEmail = ({value}) => {
    return undefined !== value && value.length > 0 && false === /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(String(value).toLowerCase());
};
const Message = () => null;
const Required = ({value}) => {
    return undefined === value || 0 === value.length;
};
const Submit = ({onClick, waiting}) => null;*/

/*Validator.Message = Message;
Validator.Required = Required;
Validator.Submit = Submit;*/

export default Validator;

